commit f12a272169523823ff27d69f187f73c4211222ae
Author: Vineet Gupta <vineetg@rivosinc.com>
Date:   Thu Aug 14 05:20:34 2025

    RISC-V: fix __builtin_round clobbering FP exceptions flags [PR121534]
    
    __builtin_round() fails to save/restore FP exception flags around the FP
    compare insn which can potentially clobber the same.
    
    Worth noting that the fflags restore bracketing is slightly different
    than the glibc implementation. Both FLT and FCVT can potentially clobber
    fflags. gcc generates below where even if branch is not taken and FCVT
    is not executed, FLT still executed. Thus FSFLAGS is placed AFTER the
    label 'L3'. glibc implementation FLT can't clobber due to early NaN check,
    so FSFLAGS can be moved under the branch, before the label.
    
    | convert_float_to_float_round
    | ...
    |   frflags     a5
    |   fabs.s      fa5,fa0
    |   flt.s       a4,fa5,fa4    <--- can clobber fflags
    |   beq a4,zero,.L3
    |     fcvt.w.s a4,fa0,rmm     <--- also
    |     fcvt.s.w  fa5,a4
    |     fsgnj.s   fa0,fa5,fa0
    | .L3:
    |    fsflags    a5            <-- both code paths
    
    Fixes: f652a35877e3 ("This is almost exclusively Jivan's work....")
    
            PR target/121534
    
    gcc/ChangeLog:
    
            * config/riscv/riscv.md (round_pattern): save/restore fflags.
    
    gcc/testsuite/ChangeLog:
    
            * gcc.target/riscv/rvv/autovec/vls/math-nearbyint-1.c: Adjust
            scan pattern for additional instances of frflags/fsrflags.
    
    Signed-off-by: Vineet Gupta <vineetg@rivosinc.com>

diff --git a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vls/math-nearbyint-1.c b/gcc/testsuite/gcc.target/riscv/rvv/autovec/vls/math-nearbyint-1.c
index bb62ce2ef8a..89af160112c 100644
--- a/gcc/testsuite/gcc.target/riscv/rvv/autovec/vls/math-nearbyint-1.c
+++ b/gcc/testsuite/gcc.target/riscv/rvv/autovec/vls/math-nearbyint-1.c
@@ -54,5 +54,5 @@ DEF_OP_V (nearbyint, 512, double, __builtin_nearbyint)
 /* { dg-final { scan-tree-dump-not "4096,4096" "optimized" } } */
 /* { dg-final { scan-assembler-times {vfcvt\.x\.f\.v\s+v[0-9]+,\s*v[0-9]+,\s*v0\.t} 30 } } */
 /* { dg-final { scan-assembler-times {vfcvt\.f\.x\.v\s+v[0-9]+,\s*v[0-9]+,\s*v0\.t} 30 } } */
-/* { dg-final { scan-assembler-times {frflags\s+[atx][0-9]+} 30 } } */
-/* { dg-final { scan-assembler-times {fsflags\s+[atx][0-9]+} 30 } } */
+/* { dg-final { scan-assembler-times {frflags\s+[atx][0-9]+} 32 } } */
+/* { dg-final { scan-assembler-times {fsflags\s+[atx][0-9]+} 32 } } */

